var assert = require('assert');
var fake = require('../lib/fake');
var sandbox = new fake.Sandbox();
var scene = new fake.Scene();

var locals = {module: {}};
var globals = {global: {}};

function fakeModule(module) {
  var fake = function() {};
  scene
    .anytime(locals, 'require')
    .args([module])
    .returnValue(fake);
  return fake;
};

var fakes = {
  sys: fakeModule('./sys'),
  Stream: fakeModule('net'),
  auth: fakeModule('./auth'),
  Parser: fakeModule('./parser'),
  OutgoingPacket: fakeModule('./outgoing_packet'),
  Query: fakeModule('./query'),
  events: fakeModule('events'),
  netConstants: fakeModule('./net_constants'),
};

scene.anytime(fakes.sys, 'inherits');
scene.anytime(fakes.events, 'EventEmitter');

sandbox.setGlobals(globals);
sandbox.setLocals(locals);
sandbox.compile(__dirname+'/../mysql/client.js');

var Client = locals.module.exports;

(function testConnect() {
  var client = new Client();

  var cbParam = scene.callback();
  cbParam.inspect = function() {
    return 'fuck';
  };
  console.log(cbParam);

  var _enqueueArgs = scene
    .expect(client, '_enqueue')
    .getArgs();

  client.connect(cbParam);

  assert.strictEqual(_enqueueArgs[1], cbParam);

  //var connect = _enqueueArgs[0];
  //console.log(connect);
})();
